/**********************************************************
Scanner 1 fr Aloisius-Automat
Ausgabealphabet:
Ende    : 0
"ha"    : 1
"l"     : 2
"le"    : 3
"lu"    : 4
"u"     : 5
"ja"    : 6
Fehler  : 7
**********************************************************/
#include <string.h>

int aloisius_scanner(char *in, int reset) {
    static char *p;
    static int delta[4][8]={/*   E h a l e u j F  */
                          /*0*/ {4,2,4,3,4,4,1,4},
                          /*1*/ {4,4,4,4,4,4,4,4},
                          /*2*/ {4,4,4,4,4,4,4,4},
                          /*3*/ {5,5,5,5,4,4,5,5}};
    static int lambda[4][8]={/*  E h a l e u j F  */
                          /*0*/ {0,7,7,7,7,5,7,7},
                          /*1*/ {7,7,6,7,7,7,7,7},
                          /*2*/ {7,7,1,7,7,7,7,7},
                          /*3*/ {2,2,2,2,3,4,1,1}};
    int chartyp[256] = {
0,7,7,7,7,7,7,7,7,7,0,7,7,0,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,2,7,7,7,4,7,7,1,7,6,7,3,7,7,2,7,7,7,7,7,5,7,7,7,7,7,7,7,7,7,7,
7,2,7,7,7,4,7,7,1,7,6,7,3,7,7,2,7,7,7,7,7,5,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7};
    int zustand = 0, token, returnval;
    if (reset) {
        p = in;
        return 0;
    }
    while (zustand < 4) {
        token=chartyp[*p++];
        returnval = lambda[zustand][token];
        zustand = delta[zustand][token];
    }
    if (zustand == 5) // Lookahead rckgngig machen
        p--;
    return returnval;
}
