/**********************************************************
Erkennender Automat fr das Frohlocken des Mnchner
Dienstmanns Alois (Engel Aloisius) im Himmel
**********************************************************/
#include <stdio.h>
#include <string.h>
//#include "automaten_aloisius_scanner1.c"
#include "automaten_aloisius_scanner2.c"

int aloisius_parser(char *in) {
    static int ptable[7][8]={/*0*/ {8,1,7,7,4,7,7,7},
                             /*1*/ {7,1,2,7,7,7,7,7},
                             /*2*/ {7,7,7,3,7,7,7,7},
                             /*3*/ {7,7,7,3,4,7,7,7},
                             /*4*/ {7,7,7,7,7,5,6,7},
                             /*5*/ {7,7,7,7,7,5,6,7},
                             /*6*/ {8,7,7,7,7,7,7,7}};
    int zustand = 0, token;
    aloisius_scanner(in, 1); // Reset

    while (zustand < 7) {
        token=aloisius_scanner(in,0);
//        printf("Zustand %d Token %d", zustand, token);
        zustand = ptable[zustand][token];
//        printf(" --> %d\n", zustand);
    }
    return zustand == 7; // 7 ist Fehlerzustand
}

int main() {
    char input[255];

    while(printf("Frohlocken: "),fgets(input, 255, stdin)!= NULL)
        printf("%sOK!\n", (aloisius_parser(input))?"Nicht ":"");

    printf("\n");
    return 0;
}
