/**********************************************************
Lexikalische Analyse fr mathematische Ausdrcke die aus
Zahlen (Fixkomma), Klammern und den Operatoren + - * /
bestehen.
**********************************************************/
#include <stdlib.h>
#include <string.h>
enum {END, PLUS, MINUS, MAL, DIV, KLA_AUF, KLA_ZU, ZAHL, FEHLER};

int mathescanner(char *input,double *wert) {

	static unsigned char myinput[255] = "";
	static int delta[][5] = {   /*     0 1 2 3 4  */
	                        	/*0*/ {4,4,6,1,6},
							    /*1*/ {5,5,2,1,5},
    							/*2*/ {6,6,6,3,6},
	    						/*3*/ {5,5,5,3,5}};
	unsigned char zeichen, wort[25], zustand = 0, klasse, lang=0;
    static int pos, klassentab[256] = {
0,4,4,4,4,4,4,4,4,4,0,4,4,0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,1,1,1,1,4,1,2,1,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4};
	if (wert == NULL) { // Reset
		strcpy(myinput, input);
		pos = 0;
		return 0;
	}
	*wert = 0;
	while (myinput[pos] == ' ' || myinput[pos] == '\t') // Leerzeichen berlesen
		pos++;
	do {
		zeichen = myinput[pos++];
        wort[lang++]=zeichen;
		zustand = delta[zustand][klassentab[zeichen]];
	} while (zustand < 4);
	wort[lang]=0;
	if (zustand == 6) return FEHLER;
	if (zustand == 5) {
	    pos--;              // Look-ahead rckgangig machen
	    wort[lang-1] = 0;   // Look-ahead rckgangig machen
        *wert = atof(wort); // wort ist korrekte Fliekommazahl!
		return ZAHL;
    }
    // Zustand = 4!!!
 	switch (wort[0]) {
		case '+':	return PLUS;
		case '-':	return MINUS;
		case '*':	return MAL;
		case '/':	return DIV;
		case '(':	return KLA_AUF;
		case ')':	return KLA_ZU;
		case '\n':
		case '\0':	return END;
	}
}