#include <stdio.h>
#include <stdlib.h>

#define END 0
#define PLUS 1
#define MINUS 2
#define MAL 3
#define DIV 4
#define ZAHL 5
#define FEHLER 6

int yylex(char *input,double *wert) {
	static int pos;
	static unsigned char myinput[255] = "";
	static int table[5][8] = {	/*0*/ {5,1,1,5,5,3,2,7},
								/*1*/ {6,6,6,6,6,3,2,6},
								/*2*/ {6,6,6,6,6,3,2,6},
								/*3*/ {7,7,7,7,7,7,4,6},
								/*4*/ {6,6,6,6,6,6,4,6}};
	int zustand = 0, klasse, lang=0;
	unsigned char zeichen, wort[25];
								
	if (strcmp(input, myinput)) {
		strcpy(myinput, input);
		pos=0;
		printf("Neuer Aufruf: %s\n",myinput);
	}
	*wert = 0;
	if (myinput[pos] == 0)
		return END;
	while (myinput[pos] == ' ')
		pos++;
	do {
//		printf("pos: %d zustand %d",pos,zustand);
		zeichen = myinput[pos++];
		wort[lang++]=zeichen;
		
//		printf(" Zeichen: '%c'",zeichen);
		if (zeichen >='0' && zeichen <= '9')
   			klasse = 6;
	   	else switch (zeichen) {
   		case 0:		klasse = 0;
   					break;
	   	case '+':	klasse = 1;
   					break;
	   	case '-':	klasse = 2;
   					break;
	   	case '*':	klasse = 3;
   					break;
	   	case '/':	klasse = 4;
   					break;
		case '.':	klasse = 5;
					break;
		default:	klasse = 7; // Fehler
		}
		zustand = table[zustand][klasse];
//		printf(" wechsle nach %d\n",zustand);
	} while (zustand < 5);
	wort[lang]=0;
	if (zustand == 6) {
		pos--;
		wort[lang-1]=0;
	}
//	printf("Separiert: '%s'\n",wort);
	if (zustand == 7)
		return FEHLER;
	if (strlen(wort) == 1)
		switch (wort[0]) {
		case '+':	return PLUS;
		case '-':	return MINUS;
		case '*':	return MAL;
		case '/':	return DIV;
	}
	*wert = atof(wort);
	return ZAHL;
}

int main() {
	char myinput[255]="-2.5 4 ++.8 2.45 -32";
	int token;
	double wert;
	
	while (token = yylex(myinput, &wert))
		printf("%d %lf\n",token,wert);
	printf("\n");
}
