/**********************************************************
**********************************************************/
#include <stdio.h>
#include "automaten_mathe_scanner.c"

void f_error();
void f_next_token();
void f_calculation();
void f_factor();
void f_expression();
void f_term();

char text[255];
int token, error;
double z;

void f_error() {
    error = 1;
}

void f_next_token() {
    token = mathescanner(text, &z);
}

void f_factor () {
    if (token == ZAHL)
        f_next_token();
    else if (token == KLA_AUF) {
        f_next_token();
        f_expression();
        if (token == KLA_ZU)
            f_next_token();
        else
            f_error();
    }
    else f_error();
}

void f_term() {
    f_factor();
    while(token == MAL || token == DIV) {
        f_next_token();
        f_factor();
    }
}

void f_expression() {
    f_term();
    while(token == PLUS || token == MINUS) {
        f_next_token();
        f_term();
    }
}

void f_calculation() {
    f_expression();
    if (token == END)
        f_next_token();
    else
        f_error();
}

int main() {
    double z;
    while(printf("Input:"), fgets(text,255,stdin)!= NULL) {
        mathescanner(text, NULL); // Scanner-Reset
        token = mathescanner(text, &z);
        error = 0;
        f_calculation();
        if (!error)
            printf("Syntax OK!\n");
        else
            printf("Syntax nicht OK!\a\n");
    }
    return 0;
}