/**********************************************************
berprfung der Eingabe einer Suchmaschine
**********************************************************/
#include <stdio.h>

int suche_scanner(char *, int);
int suchne_parser(char *);

int main() {
    char input[255];

    while(printf("BCD-Input: "),fgets(input, 255, stdin)!= NULL)
        printf("%sOK!\n", (suche_parser(input))?"Nicht ":"");

    printf("\n");
    return 0;
}

int suche_parser(char *in){
    int zustand = 0;
    int ptable[3][5] = {/*0*/ {3,3,3,3,1},
                        /*1*/ {4,2,2,2,3},
                        /*2*/ {3,3,3,3,1}};
    suche_scanner(in, 1); // Scanner-Reset
    while (zustand < 3)
        zustand = ptable[zustand][suche_scanner(in, 0)];
    return zustand == 3;
}

int suche_scanner(char *in, int reset) {
    static char *p, wort[255];
    enum {token_end, token_and, token_or, token_not, token_wort};
    if (reset) {
        p = in;
        return 0;
    }
    while (*p == ' ')
        p++;
    if (sscanf(p, "%s", wort) == EOF)
        return token_end;
    p += strlen(wort);
    if (!strcmp(wort, "AND"))
        return token_and;
    if (!strcmp(wort, "OR"))
        return token_or;
    if (!strcmp(wort, "NOT"))
        return token_not;
    return token_wort;
}
