c_menge::c_menge() { // Konstruktor
    anzahl = 0;
}

c_menge::~c_menge() { // Destruktor
}

void c_menge::rein(int zahl) {
    if (pos(zahl) < 0) // Menge enthlt Zahl noch nicht
        zahlen[anzahl++] = zahl;
}

void c_menge::raus(int zahl) {
}

int c_menge::pos(int zahl) { // private!!!
    int p = -1;
    for (int i=0; i<anzahl; i++)
        if (zahlen[i] == zahl)
            p = i;
    return p;
}

ostream& operator << (ostream& out, c_menge m){
    out << "{";
    for (int i=0; i < m.anzahl; i++) {
        if (i)
            out << ";";
        out << m.zahlen[i];
    }
    out << "}";
    return out;
}

void c_menge::leeren(void) {
    anzahl = 0;
}

c_menge c_menge::operator + (int zahl) {
    c_menge result;
    for (int i=0; i<anzahl; i++)
        result.rein(zahlen[i]);
    result.rein(zahl);
    return result;
}

c_menge c_menge::operator + (c_menge m) {
    c_menge result;
    for (int i=0; i<anzahl; i++)
        result.rein(zahlen[i]);
    for (int i=0; i<m.anzahl; i++)
        result.rein(m.zahlen[i]);
    return result;
}

c_menge c_menge::operator * (c_menge m) {
    c_menge result;
    for (int i=0; i<anzahl; i++) {
        int z = zahlen[i];
        if (m[z])
            result.rein(z);
    }
    return result;
}

int c_menge::operator [] (int zahl) {
    return (pos(zahl) >= 0);
}

c_menge vereinigungsmenge(c_menge m1, c_menge m2) {
    c_menge ergebnis;
    for (int i=0; i<m1.anzahl; i++)
        ergebnis.rein(m1.zahlen[i]);
    for (int i=0; i<m2.anzahl; i++)
        ergebnis.rein(m2.zahlen[i]);
    return ergebnis;
}

c_menge schnittmenge(c_menge m1, c_menge m2) {
    c_menge ergebnis;
    for (int i=0; i<m1.anzahl; i++)
        if (m2.pos(m1.zahlen[i]) >= 0)
            ergebnis.rein(m1.zahlen[i]);
    return ergebnis;
}