#ifndef _C_STRING_H
	#define _C_STRING_H
class c_string {
public:
// Konstruktoren und Destruktoren
	c_string(void);
	c_string(char *);
	c_string(const c_string&);
	~c_string(void);

// Methoden
	unsigned int length(void);      // Lnge des Strings
	c_string upper(void);           // Grobuchstaben
	c_string lower(void);           // Kleinbuchstaben
	
// Operatoren
	friend ostream& operator << (ostream&, c_string);
	friend istream& operator >> (istream&, c_string&);
	c_string operator + (c_string);
	void operator = (c_string);
	void operator = (char *);
	void operator += (c_string);
	int operator == (c_string&);
	int operator != (c_string&);
	int operator < (c_string&);
	int operator > (c_string&);
	int operator <= (c_string&);
	int operator >= (c_string&);
	int operator == (char *);
	int operator != (char *);
	c_string operator [] (int);

private:
	unsigned int l;
	char *s;
	void set(char *);
	void set(char *, unsigned int);
};
	
	
	#include "cpp_c_string.cpp"
#endif

