#ifndef _C_ULTRALONGINT_
#define _C_ULTRALONGINT_ 1
#include <stdio.h>
#include <stream.h>
#include <string.h>

#define M_MAX 40
class c_ultralongint {
public:
    c_ultralongint();
    c_ultralongint(long int);
    ~c_ultralongint();
    friend ostream& operator << (ostream&, c_ultralongint&);
    friend istream& operator >> (istream&, c_ultralongint&);
    c_ultralongint operator + (c_ultralongint);
    c_ultralongint operator - (c_ultralongint);
    c_ultralongint operator - ();
    c_ultralongint operator ++ ();   // Prfix-Increment
    c_ultralongint operator ++ (int); // Postfix-Increment
//    c_ultralongint operator = (c_ultralongint);
    c_ultralongint& operator = (long int);
private:
    char w[M_MAX];
    char neg;
    void null(void);
    void intset(long int);
};
#include "cpp_c_uli.cpp"
#endif