/**********************************************************
Klasse c_vektor
Quellcode-Datei
**********************************************************/

c_vektor::c_vektor() {
    set(0,0);
}

c_vektor::c_vektor(double _x, double _y) {
    set(_x, _y);
}

void c_vektor::set(double _x, double _y) {
    x = _x;
    y = _y;
}

ostream& operator << (ostream& out, const c_vektor& v) {
    out << "(" << v.x << "/" << v.y << ")";
    return out;
}

istream& operator >> (istream& in, c_vektor& v) {
    in >> v.x >> v.y;
    return in;
}

c_vektor c_vektor::operator + (c_vektor rechts) {
    c_vektor result(x + rechts.x, y + rechts.y);
    return result;
}

c_vektor c_vektor::operator - (c_vektor rechts) {
    c_vektor result(x - rechts.x, y - rechts.y);
    return result;
}

c_vektor c_vektor::operator - () {
    c_vektor result(-x, -y);
    return result;
}

c_vektor c_vektor::operator * (double f) {
    c_vektor result(x * f, y * f);
    return result;
}

double c_vektor::operator * (c_vektor rechts) {
    return 0;
}

double c_vektor::operator [] (char index) {
    index = toupper(index);
    if (index != 'X' && index != 'Y') {
        cerr << "Indexfehler!!!" << endl;
        return 0;
    }
    return (index == 'X') ? x : y;
}

double c_vektor::get_x(void) {
    return x;
}

void c_vektor::set_x(double zahl) {
    x = zahl;
}

double c_vektor::get_y(void) {
    return y;
}

void c_vektor::set_y(double zahl) {
    y = zahl;
}
