/************************************************************
Die ersten 10 Quadratzahlen und Quadratwurzeln
Es mssen zwei Parameter bergeben werden, der erste ist der
Dateiname der Ausgabedatei, der zweite das Dateiformat,
er muss 'csv' oder 'fix' lauten
************************************************************/
#include <stdio.h>
#include <math.h>

void change(char *);

int main(int ac, char *a[]) {
    FILE *out;
    char ostr[200], fstr[255];
    int i;

    if (ac != 3 || strcmp(a[2],"csv") && strcmp(a[2],"fix")) {
        fprintf(stderr, "Parameter 1: Dateiname\n");
        fprintf(stderr, "Parameter 2: 'csv' oder 'fix'!\n");
        return 1; // Parameter-Fehler
    }
    strcpy(fstr,(*a[2]=='c') ? "%d;%d;%lf\n" : "%5d%5d%10.6lf\n");

    out = fopen(a[1], "w");
    if (out == NULL) {
        fprintf(stderr,"Fehler Ausgabedatei!\n");
        return 2; // Dateifehler
    }

    for (i=1; i<=10; i++) {
        sprintf(ostr,fstr,i,i*i,sqrt(i));
        change(ostr);
        printf("%s", ostr);
        fprintf(out, "%s", ostr);
    }
    fclose(out);
    printf("Ausgabedatei wurde erfolgreich erstellt!\n");
    return 0;
}

void change(char *p) { // Ersetzt im String *p Punkte durch Kommas
    p--;
    while (*(++p) = (*p == '.') ? ',' : *p);
}