#include <stdio.h>
#include <malloc.h>

struct element {
    double value;
    struct element *next;
};

struct element *start = NULL, *ende = NULL;

int addqueue(double v) {
// Speichert am Ende der Schlange
    struct element *neu = (struct element *) malloc(sizeof(struct element));

    if (neu == NULL) return 1;
    (*neu).value = v;
    (*neu).next = NULL;
    if (start == NULL) // Schlange war leer
        start = neu;
    else
        (*ende).next = neu;
    ende = neu;
    return 0;
}

int dropqueue(double *v) {
// Lscht am Kopf der Schlange und gibt Wert zurck
    struct element *puffer;

    if (start == NULL) return 1;
    *v = (*start).value;
    puffer = start;
    start = (*start).next;
    if (start == NULL)
        ende = NULL;
    free(puffer);
    return 0;
}

void printqueue(){
    struct element *lauf = start;
    int nr = 0;
    printf("\nQueue:\n--------------");
    while (lauf != NULL) {
        printf("\n%d: %lf",nr++,(*lauf).value);
        lauf = (*lauf).next;
    }
    printf("\n----------------\nLnge: %d",nr);
}

int main () {
    char wahlstring[10];
    double zahl;
    int wahl;

    do {
        printqueue();
        printf("\n1) In Schlange speichern");
        printf("\n2) Von Schlange zurcklesen");
        printf("\n3) Ende");
        printf("\nIhre Wahl: ");
        scanf("%s",wahlstring);
        wahl = atoi(wahlstring);
        if (wahl == 1) {
            printf("\nZahl eingeben: ");
            scanf("%lf",&zahl);
            if (addqueue(zahl))
                printf(" Kein Speicherplatz mehr!");
        }
        if (wahl == 2) {
            if (!dropqueue(&zahl))
                printf("\nErgebnis: %lf",zahl);
            else
                printf("\nSchlange war leer!");
        }
    } while (wahl != 3);
    return 0;
}
