#include <stdio.h>
#include <malloc.h>

struct element {
    double value;
    struct element *next;
};

struct element *start;

int addstack(double v) {
    struct element *neu = (struct element *) malloc(sizeof(struct element));

    if (neu == NULL) return 1;
    (*neu).value = v;
    (*neu).next = start;
    start = neu;
    return 0;
}

int dropstack(double *v) {
    struct element *puffer;

    if (start == NULL) return 1;
    *v = (*start).value;
    puffer = start;
    start = (*start).next;
    free(puffer);
    return 0;
}

void printstack(){
    struct element *lauf = start;
    int nr = 0;
    printf("\nStack:\n--------------");
    while (lauf != NULL) {
        printf("\n%d: %lf",nr++,(*lauf).value);
        lauf = (*lauf).next;
    }
    printf("\n----------------\nStackhhe: %d",nr);
}

int main () {
    char wahlstring[10];
    double zahl;
    int wahl;

    do {
        printstack();
        printf("\n1) Auf Stack speichern");
        printf("\n2) Von Stack zurcklesen");
        printf("\n3) Ende");
        printf("\nIhre Wahl: ");
        scanf("%s",wahlstring);
        wahl = atoi(wahlstring);
        if (wahl == 1) {
            printf("\nZahl eingeben: ");
            scanf("%lf",&zahl);
            if (addstack(zahl))
                printf(" Kein Speicherplatz mehr!");
        }
        if (wahl == 2) {
            if (!dropstack(&zahl))
                printf("\nErgebnis: %lf",zahl);
            else
                printf("\nStack war leer!");
        }
    } while (wahl != 3);
    return 0;
}
