/**********************************************************
Demonstriert Felder als Parameter
**********************************************************/
#include <stdio.h>

void feldausgabe(int *, int);   // Zeiger-Syntax
void feldumdrehen(int [], int [], int); // Array-Syntax

int main() {
    int a[3] = {1,2,3}, b[4] = {11,12,13,14}, c[3];

    feldausgabe(a, 3);
    feldumdrehen(a, c, 3);
    feldausgabe(c, 3);
    feldausgabe(b, 4);
    return 0;
}

void feldausgabe(int *feld, int groesse) {
    int i;
    for (i = 0; i < groesse; i++)
        printf("%c%d", (i > 0) ? ',' : '(', *(feld + i));
    printf(")\n");
}

void feldumdrehen(int feld1[], int feld2[], int groesse) {
    int i;
    for (i = 0; i < groesse; i++)
        feld2[groesse - 1 - i] = feld1[i];
}
