/**********************************************************
Demonstriert Verwendung von Strukturen als
Funktionsparameter und als Funktionstyp
**********************************************************/
#include <stdio.h>

struct vektor {  // Global deklarierte Struktur "vektor"
    double x, y;
};

struct vektor vektoraddition(struct vektor,struct vektor);
void vektorausgabe(struct vektor);

int main() {
    struct vektor v1 = {1,2}, v2 = {3,4}, v3;
    v3 = vektoraddition(v1, v2);
    vektorausgabe(v1);
    printf(" + ");
    vektorausgabe(v2);
    printf(" = ");
    vektorausgabe(v3);
    printf("\n");
    return 0;
}
struct vektor vektoraddition(struct vektor v1, struct vektor v2) {
    struct vektor vsumme;
    vsumme.x = v1.x + v2.x;
    vsumme.y = v1.y + v2.y;
    return vsumme;
}
void vektorausgabe(struct vektor v) {
    printf("(%.2lf/%.2lf)", v.x, v.y);
}
