/******************************************************************
Nullstellenbestimmung nherungsweise nach der Mittelwertregel
f(x) = x^2 - 2, x1=0 und x2=100 fest einprogrammiert
******************************************************************/
#include <stdio.h>

double f(double);
int signum(double);

int main() {
    double x1=0, x2=100, xm, deltax=1e-3;
    int anzahl=0, error = 0;
	
    do {
        printf("%3d:\t%.10lf %.10lf\n", ++anzahl, x1, x2);
        if (signum(f(x1)) == signum(f(x2)))
            error = 1;
        else {
            xm = (x1 + x2) / 2;
            if (signum(f(x1)) ==  signum(f(xm)))
                x1 = xm;
            else
                x2 = xm;
        }
    } while ( !error && x2 - x1 > deltax);
    if (error) {
        printf("Fehler!\n");
        return 1;
    }
    printf("Berechnung der Nullstelle von y=x^2 - 2:\n");
    printf("Zwischen %lf und %lf\n", x1, x2);
    return 0;
}

double f(double x) { // Hier ist die Funktion einprogrammiert
    return x * x - 4;
}

int signum(double x) {
    return (x>0) - (x<0);
}