/****************************************************
Prim-Eigenschaft als Funktion	
****************************************************/
#include <stdio.h>
#include <math.h>

int prim(int zahl) {
	int lauf = 3, istprim=1, grenze = (int) sqrt(zahl);

	if (zahl <= 1)
	    return 0;
	if (zahl % 2 == 0) // Gerade Zahlen
	    return (zahl==2); //Nur 2 ist prim
	while (lauf <= grenze && (istprim = (zahl % lauf != 0)))
		lauf +=2;
    return istprim;
}

int main() {
	int zahl;
	
	printf("Geben Sie eine Integer-Zahl ein:");
	scanf("%d", &zahl);
	if (prim(zahl) == 1)
        printf("%d ist prim!\n", zahl);
    else
        printf("%d ist nicht prim!\n", zahl);
	printf("\n");
    return 0;
}