/**********************************************************
Drehen eines Vektors
Modul drehe mit Funktionswertrckgabe einer Struktur
**********************************************************/
#include <stdio.h>
#include <math.h>

struct vektor {
    double x;
    double y;
};

// Prototypen
struct vektor drehe(struct vektor , double);
void ausgabe(struct vektor, char *);

int main() {
    struct vektor u;
    double winkel;

    printf("Geben Sie die Vektorkoordinaten sowie ");
    printf("den Drehwinkel in Grad ein:");
    scanf("%lf%lf%lf", &u.x, &u.y, &winkel);
    ausgabe(u, "Vor Drehung:");
    u = drehe(u, winkel);
    ausgabe(u, "Nach Drehung:");
}

struct vektor drehe(struct vektor v, double alpha) {
    struct vektor result;
    double c, s;
    alpha = alpha / 180 * M_PI; // M_PI in math.h definiert
    c = cos(alpha); // Reduziert cos- und sin-Berechnungen
    s = sin(alpha);
    result.x = v.x * c - v.y * s;
    result.y = v.x * s + v.y * c;
    return result;
}

void ausgabe(struct vektor v, char *text) {
    printf("%s\t[%lf/%lf]\n", text, v.x, v.y);
}
