/**********************************************************
Quicksort
**********************************************************/
#include <stdio.h>
#define MAX 8
int a[MAX] = {4,2,8,7,1,6,3,5};

void ausgabe(int , int, int, int);

void quicksort(int links, int rechts)
{
	int li=links, re=rechts, test = a[(links + rechts)/2];
	int i, swap;
	
	printf("\n\nQuicksort-Aufruf, Testzahl ist %d\n", test);
	ausgabe(links, rechts, li, re);
	do {
	    while (a[li] < test)
	        li++;
	    while (a[re] > test)
	        re--;
	    if (li <= re) {
    	    printf("Zu tauschen:\n");
        	ausgabe(links, rechts, li, re);
            swap = a[li];
            a[li] = a[re];
            a[re] = swap;
            li++;
            re--;
        	printf("Nach Tausch:\n");
        	ausgabe(links, rechts, li, re);
	    }
	} while (li <= re);
	printf("Quicksort beendet!\n");
	if (links < re)
    	quicksort(links, re);
    if (li < rechts)
    	quicksort(li, rechts);
}

int main() {
    int i;

    printf("Ausgangswerte: ");
    for (i=0; i<MAX; i++)
        printf("%4d", a[i]);
    printf("\n");
	quicksort(0, MAX-1);
    printf("Nach quicksort:");
    for (i=0; i<MAX; i++)
        printf("%4d", a[i]);
    printf("\n");
	return 0;
}

void ausgabe(int links, int rechts, int ml, int mr) {
    int i;
    for (i=links; i<=rechts; i++)
        printf("\t%d", a[i]);
    printf("\n");
    for (i=links; i<=rechts; i++)
        printf("\t%c", (i == ml || i == mr) ? '|' : ' ');
    printf("\n");
    for (i=links; i<=rechts; i++)
        printf("\t%c", (i != ml && i != mr) ? ' ' : ((i == ml) ?'l':'r'));
    printf("\n");

}
