/*************************************************
Rsslsprung-Problem
*************************************************/
#include <stdio.h>
#define N 5
char feld[N][N];

void ausgabe() {
    int i,j;
    static int loesungszahl;
    printf("\n\nLsung %d:\n",++loesungszahl);		
    for (i=N-1; i>=0; i--) {
        printf("\n");
        for (j=0; j<N; j++)
            printf("%3d",feld[j][i]);
    }
    printf("\nBitte eine Taste drcken...");
//    getchar(); // evtl auskommentieren
}

void springerzug(int spalte,int zeile, int zugtiefe) {
    int i;
    static int zug[8][2]
    = {{2,1},{2,-1},{-2,1},{-2,-1},{1,2},{1,-2},{-1,2},{-1,-2}};

    if (zeile >= 0 && zeile < N && spalte >= 0 &&  spalte < N
    && !feld[spalte][zeile])
    { // Zug innerhalb Schachbrett und Feld frei
        feld[spalte][zeile]=zugtiefe; // Feld besetzen
        if (zugtiefe < (N*N))
            for (i=0; i<8; i++)
                springerzug(spalte+zug[i][0], zeile+zug[i][1],
                zugtiefe+1);
        else// N^2 Zge haben funktioniert
            if (zeile == N-1 && spalte == N-1) // Ecke rechts oben
                ausgabe();
        feld[spalte][zeile]=0; // Feld freigeben
    }
}

int main() {
    int i,j;
    for (i=0; i<N; i++)
        for (j=0; j<N; j++)
            feld[i][j]=0;
	
    springerzug(0,0,1); // Erster Zug auf Feld 0/0
    printf("\n");
    return 0;
}
