#include <stdio.h>
typedef enum{
    adorf, bdorf, cdorf, ddorf, edorf, fdorf, gdorf, hdorf
} dorf;
char namen[][10]={
    "adorf","bdorf","cdorf","ddorf","edorf","fdorf","gdorf","hdorf"
};
void fahre(dorf von, dorf nach) {
    static int distanz[8][8] ={ {0,4,3,2,5,0,0,0},
                                {4,0,2,0,0,5,3,0},
                                {3,2,0,0,0,2,0,0},
                                {2,0,0,0,2,3,0,0},
                                {5,0,0,2,0,4,0,0},
                                {0,5,2,3,4,0,3,2},
                                {0,3,0,0,0,3,0,4},
                                {0,0,0,0,0,2,4,0}};
    static int belegt[8] = {0,0,0,0,0,0,0,0}, zug[8], nr;
    int i, km = 0;
    dorf d;

    belegt[von] = 1;    // Stadt belegen
    zug[nr++] = von;

    if (von == nach) { // Am Ziel angekommen
        printf("%d Stdte: %s", nr, namen[zug[0]]);
        for (i=1; i<nr; i++) {
            km += distanz[zug[i]][zug[i-1]];
            printf("-%s",namen[zug[i]]);
        }
        printf("\t-> %d km\n", km);
    }
    else
        for (d=adorf; d<=hdorf; d++)
            if (d!=von && !belegt[d] && distanz[d][von])
                fahre(d, nach);
    nr--;
    belegt[von] = 0;
}

int main() {
    fahre(adorf, hdorf);
    return 0;
}