/***************************************************************
Programm zur Demonstration der Probleme bei for-Schleifen mit
Fliekommazahlen als Schleifenzhler
***************************************************************/
#include <stdio.h>

int main() {
    int i, anzahl;
    float x, summe;

    printf("Jetzt die Schleife mit der float-Variablen:\n");
    summe=0;
    anzahl=0;
    for (x=1000; x <= 1000.05; x += .001) {
        summe += x;
        anzahl++;
    }
    printf("Summe: %f, Anzahl: %d\n", summe, anzahl);

    printf("\nJetzt die Schleife mit der int-Variablen:\n");
    summe=0;
    anzahl=0;
    for (i=0; i <= 50; i ++) {
        x = 1000 + (float) i / 1000;
        summe += x;
        anzahl++;
    }
    printf("Summe: %f, Anzahl: %d\n", summe, anzahl);

    printf("\nJetzt direkt nach Gauss:\n");
    summe = (float) 51000 + (float) (50 * 51) / (float) 2000;
    printf("Summe: %f, keine Schleife!\n", summe);

    printf("\nDas Ergebnis sollte jedesmal sein: 51001.275!\n");
    return 0;
}