/******************************************************************
Nullstellenbestimmung nherungsweise nach der Mittelwertregel
y = x^2 -2, x1=0 und x2=100 fest einprogrammiert
******************************************************************/
#include <stdio.h>

int main() {
    double x1=0, x2=100, xm, y1, ym, deltax=1e-3;
    int anzahl=0;
	
    do {
        printf("%3d:\t%.10lf %.10lf\n", ++anzahl, x1, x2);
        xm = (x1 + x2) / 2;
        ym = xm * xm - 2;
        y1 = x1 * x1 - 2;
        if (y1 * ym > 0 ) // Vorzeichen sind gleich
            x1 = xm;
        else
            x2 = xm;
    } while (x2 - x1 > deltax);
    printf("Berechnung der Nullstelle von y=x^2 - 2:\n");
    printf("Zwischen %lf und %lf\n", x1, x2);
}