/************************************************************
Sortiern durch direktes Tauschen
************************************************************/
#include <stdio.h>
void ausgabe(int[], int, int);
void tausch_sort(int [], int);

int main() {
    int feld[]={8,7,5,2,4,3,6,1}; // Zu sortierendes Feld
    tausch_sort(feld, 8);
    return 0;
}

void tausch_sort(int feld[], int n) {
	int lauf, i, dummy, pos, minwert;
	ausgabe(feld, n, 0);
    lauf = -1;
    for (lauf=0; lauf < n - 1; lauf++) {
	    minwert = feld[lauf];
	    pos = lauf;
		for (i = lauf + 1; i < n; i++)
		    if (feld[i] < minwert){
		        pos = i;
		        minwert = feld[i];
		    }
		    if (pos != lauf) { // Dreieckstausch
				dummy=feld[lauf];
				feld[lauf]=feld[pos];
				feld[pos]=dummy;
			}
        ausgabe(feld, n, lauf+1);
    }
}


void ausgabe(int feld[], int n, int durchgang) {
    int j;
	printf("Durchgang %d:", durchgang);
	for (j = 0; j < n; j++)
		printf("%3d", feld[j]);
    printf("\n");
}
