/**********************************************************
Berechnung von Pi ber Spigot-Algorithmus
Nach Spektrum der Wissenschaft 12/1995 S. 10 ff.
**********************************************************/
#include <stdio.h>

int main() {
    unsigned int n, i, j, m, anz;
    unsigned int *feld, r, q, stellen[20], stellenz = 0;

    fprintf(stderr,"Geben Sie n (Anzahl der Stellen) ein: ");
    scanf("%d", &n);

    anz = 3 * n + 1;
    fprintf(stderr, "anz: %d\n", anz);
    feld = (unsigned int *) malloc(anz * sizeof(unsigned int));
    if (feld == NULL) {
        fprintf(stderr, "Nicht genug Speicher!\n");
        return 1;

    }

    for (i=0; i<anz; i++)
        feld[i] = 2; // Initialisierung

    for (j=1; j<=n; j++) {
        for (i=0; i<anz; i++)
            feld[i] *= 10;

        for (m = anz - 1; m >= 1; m--) {
            q = feld[m] / (2 * m + 1);
            r = feld[m] % (2 * m + 1);
            feld[m] = r;
            feld[m-1] += (q * m); // Achtung Zahlenbereich!!!
        }
        q = feld[0] / 10;
        feld[0] %= 10;
        switch (q) {
        case 9:     stellen[stellenz++] = q;
                    break;
        case 10:    for (i=0; i < stellenz; i++)
                        printf("%d", (stellen[i]+1) % 10);
                    stellen[0] = 0;
                    stellenz = 1;
                    break;
        default:    for (i=0; i < stellenz; i++)
                        printf("%d", stellen[i]);
                    stellen[0] = q;
                    stellenz = 1;
        }
        fflush(stdout);
    }
    free(feld);
    printf("\n");
}
