#include <stdio.h>
#define N 8
int feld[N][N];

//Prototypen:
void ausgabe();             // Gibt Spielfeld aus
void achtdamen(int);        // Rekursive Funktion
int feldbedroht(int, int);  // Prft ob Feld bedroht ist

int main() {
    int i, j;
    for (i=0; i<N; i++)     // Initialisierung Spielfeld
        for (j=0; j<N; j++)
            feld[i][j]=0;

    achtdamen(0);
    return 0;
}

void achtdamen(int zeile) {
    int spalte;

    for (spalte=0; spalte < N; spalte++)
        if (!feldbedroht(zeile,spalte)) {
            feld[zeile][spalte] = 1;
            if (zeile == N-1)
                ausgabe();
            else
                achtdamen(zeile+1); // Rekursion
            feld[zeile][spalte] = 0;
        }
}

int feldbedroht(int zeile, int spalte) {
// Gibt 1 zurck falls feld[zeile][spalte] bedroht ist
// andernfalls Rckgabe 0
    int bedroht = 0, i , z1, z2;
    for (i=0; i<N; i++) {
        z1 = zeile-spalte+i; // Diagnonale 1
        z2 = zeile+spalte-i; // Diagnonale 2
        if (feld[zeile][i] || feld[i][spalte]
            || (z1 >=0 &&  z1 < N && feld[z1][i])
            || (z2 >=0 &&  z2 < N && feld[z2][i]) )
            bedroht = 1;
    }
    return bedroht;
}

void ausgabe() {
    int z, s;
    static int loesung;

    printf("\nLsung %d:\n+", ++loesung);
    for (s = 0; s < N; s++)
        printf("-+");
    printf("\n");
    for (z=N-1; z>=0; z--) {
        for (s=0; s<N; s++)
            printf("|%c",(feld[z][s])?'*':' ');
        printf("|\n+");
        for (s = 0; s < N; s++)
            printf("-+");
        printf("\n");
    }
}