#include <stdio.h>
#include <string.h>
#include <ctype.h>

int main(int argc, char * argv[]) {
    unsigned char c, vokal, ersetz[255];
    int i;
    FILE * f;
    if (argc != 3) {
        fprintf(stderr, "Parameter 1: Inputfile\n");
        fprintf(stderr, "Parameter 2: Vokal\n");
        return 1;
    }
    if (strlen(argv[2]) != 1) {
        fprintf(stderr, "Parameter 2 nur ein Zeichen!\n");
        return 2;
    }
    if (strchr("AEIOUaeiou", argv[2][0]) == NULL) {
        fprintf(stderr, "Parameter 2: Vokal\n");
        return 3;
    }
    if ((f = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Datei kann nicht geffnet werden!\n");
        return 4;
    }
    // Fehlerberprfung jetzt beendet!
    vokal = argv[2][0];
    for (i = 0; i<256; i++) // Ersetzungstabelle initialisieren
        ersetz[i] = i;
    ersetz['A'] = ersetz['E'] = ersetz['I'] = ersetz['O']
        = ersetz['U'] = toupper(vokal);
    ersetz['a'] = ersetz['e'] = ersetz['i'] = ersetz['o']
        = ersetz['u'] = tolower(vokal);

    while (fscanf(f, "%c", &c) != EOF)
        fprintf(stdout, "%c", ersetz[c]);
    fclose(f);
    fprintf(stdout, "\n");
    return 0;
}