/**********************************************************
Programm berechnet alle mglichkeiten, wie 2.50 DM mit
0.10-, 0.50-, 1.00- und 2.00-DM-Mnzen bezahlt werden kann.
**********************************************************/
#include <stdio.h>
#define MAX_REKURSION 50
void automat(int zahlen, int level)
{
    static int coin[]={10, 50, 100, 200, -1};
    static int folge[MAX_REKURSION], solve;
    int i;

    if (level == MAX_REKURSION) {
        printf("Rekursions-berlauf!\n");
        return;
    }

    if (zahlen > 0) {//Rekursionsbedinung
        i = -1;
        while (coin[++i] > 0){
            folge[level]=coin[i];
            automat(zahlen - coin[i], level+1);
        }
    }
    else if (zahlen == 0)     //Lsung gefunden
    {
        printf("%d. Lsung (%d Mnzen):\n", ++solve, level);
        for (i = 0; i < level; i++)
            printf("%4d", folge[i]);
        printf("\n");
    } // Jetzt kme "ber-bezahlt", da passiert aber nix
}

int main()
{
    int betrag;
    printf("Geben Sie den Betrag in ganzen DPf ein: ");
    scanf("%d", &betrag);
    automat(betrag, 0);
    return 0;
}
