#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#define FELDG 8
#define BOMBEN 10
int feld[FELDG][FELDG];

int bombenzahl(int z, int s) {
    int i, j, b = 0;

    for (i=z-1; i<=z+1; i++)
        for (j=s-1; j<=s+1; j++)
            if (i>=0 && i<FELDG && j>=0 && j<FELDG && feld[i][j]==1)
                b++;
    return b;
}

void ausgabe() {
    int i,j, b;

    printf("\n");
    printf("  +");
    for (i=0; i<FELDG; i++)
        printf("-");
    printf("+\n");
    for (i=FELDG-1; i>=0; i--) {
        printf("%2d|",i+1);
        for (j=0; j<FELDG; j++)
            printf("%c",(feld[i][j]==2)?bombenzahl(i,j)+'0':' ');
        printf("|\n");
    }
    printf("  +");
    for (i=0; i<FELDG; i++)
        printf("-");
    printf("+\n   ");
    for (i=0; i<FELDG; i++)
        printf("%c",i+65);
    printf("\n");
}

int main() {
    int i, j, zugnr=0, baeng=0, t=time(NULL), bombenzahl=0;
    char aw[255];
    for (i=0; i<FELDG; i++)
        for (j=0; j<FELDG; j++)
            feld[i][j]=0;
    for (bombenzahl=0; bombenzahl < BOMBEN; bombenzahl++) {
        do {
            i=(int)((double) rand() / RAND_MAX * FELDG);
            j=(int)((double) rand() / RAND_MAX * FELDG);
        } while (feld[i][j]);
        feld[i][j] = 1;
        printf("Bombe auf %c%c\n", j+'A', i+'1');
    }

    ausgabe();
    printf("%d Bomben!\n", bombenzahl);
    do {
        printf("Zug %d: ", ++zugnr);
        scanf("%s", aw);
        j=toupper(aw[0])-'A';
        i = aw[1] - '1';
        if (feld[i][j]==1)
            baeng=1;
        else {
            feld[i][j] = 2;
            ausgabe();
        }
    } while (zugnr+bombenzahl < FELDG*FELDG && !baeng);
    if (baeng)
        printf("Schade!\n");
    else
        printf("Gratulation! %d sec\n", time() - t);
}
