/********************************************************
Pi nach monte-Carlo-Methode berechnen
********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <limits.h>

int main () {
    unsigned int i, treffer=0, anzahl=10000000;
    double x, y;

    srand(time(NULL));

    for (i=0; i<anzahl; i++) {
        x = (double) rand() / RAND_MAX;
        y = (double) rand() / RAND_MAX;
        if (x*x + y*y <= 1)
            treffer++;
    }
    printf("pi ca. %lf\n", (double) 4 * treffer / anzahl);
}
