#include <stdio.h>
#include <string.h>

int main(int argc, char * argv[]){
    FILE *in, *out;
    char wort[80], wort2[80];
    int i, j, anz = 0;
    if (argc != 3) {
        fprintf(stderr, "Zwei Dateiname als Parameter!\n");
        return 1;
    }

    if ((in = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Eingabedatei kann nicht geffnet werden!\n");
        return 2;
    }
    if ((out = fopen(argv[2], "w+")) == NULL) {
        fprintf(stderr, "Ausgabedatei kann nicht geffnet werden!\n");
        fclose(in);
        return 3;
    }
    while(fscanf(in, "%s", wort) != EOF) {
        anz++;
        fprintf(out, "%72s\n", wort);
    }
    fclose(in);
    for (i=0; i< anz; i++) // Bubble-Sort
        for (j = 0; j < anz - 1; j++) {
            fseek(out, 73 * j, SEEK_SET);
            fscanf(out, "%s%s", wort, wort2);
            if (strcmp(wort, wort2) < 0) {
                fseek(out, 73 * j, SEEK_SET);
                fprintf(out, "%72s\n%72s\n", wort2, wort);
            }
        }

    strcpy(wort2, "");
    fseek(out, 0, SEEK_SET);
    anz = 0;
    while (fscanf(out, "%s", wort) != EOF)
        if (!strcmp(wort, wort2)) // Gleiches Wort nochmal
            anz++;
        else { // Neues Wort
            printf("Wort '%s': %d\n", wort2, anz);
            strcpy(wort2, wort);
            anz = 1;
        }
    printf("Wort '%s': %d\n", wort2, anz);

    fclose(out);
    return 0;
}