/**********************************************************
Lsung der allgemeinen quadratischen Gleichung
nach Mitternachtsformel bzw. Geradengleichung
**********************************************************/
#include <stdio.h>
#include <math.h>

int main() {
    double a,b,c,d,x1,x2;
    /* a,b,c: Koeffizienten der Parabel;
    d: Diskrimante; x1,x2: Nullstellen */
	
    printf("Lsung der Gleichung y = a x^2 + b x +c");
    printf("\nGeben Sie die Koeffizienten a, b und c ein: ");
    scanf("%lf%lf%lf",&a, &b, &c);
    printf("\ny = %4.2lf x^2 + %4.2lf x + %4.2lf\n\n",a,b,c);
	
    if (a == 0) {// Keine Parabel, Gerade!!!
        printf("Gerade ");
        if (b == 0) { // Gerade mit Steigung 0
            printf("y=%lf ", c);
            printf("%s Nullstellen", (c) ? "keine" : "alles");
        }
        else { // Gerade mit Steigung <> 0
            x1 = -c / b;
            printf("mit Nullstelle bei %lf",x1);
        }
    }
    else { // Parabel
        printf("Parabel ");
        d = b*b - 4*a*c;
        switch ((d>0) - (d<0)) { // signum(d)
        case +1: // Zwei Nullstellen
            x1 = -b + sqrt(d) / (2 * a);
            x2 = -b - sqrt(d) / (2 * a);
            printf("mit zwei Nullstellen bei %lf und %lf",x1,x2);
            break;
        case 0: // Eine Nullstelle
            x1 = -b / (2 * a);
            printf("mit einer Nullstelle bei %lf",x1);
            break;
        case -1: // Keine Nullstelle
            printf("ohne Nullstellen");
        }
    }
    printf("\n");
    return 0;
}
