/**********************************************************
Berechnung der Farbcodes von Widerstnden
**********************************************************/
#include <stdio.h>
#include <math.h>

int eingabe(int, int);
void farbe_rwert(int);
void rwert_farbe(int);

char farbtext[][10]= {"schwarz","braun","rot","orange",
                        "gelb","grn","blau","violett",
                        "grau","weiss"};

int main() {
    int wahl, farben;
    do {
        printf("1)\tWert -> Farbde\n2)\tFarbe -> Wert\n");
        wahl = eingabe(1,2);
        printf("3)\t3-Ring-Code\n4)\t4-Ring-Code\n");
        farben = eingabe(3,4);
        if (wahl == 1)
            rwert_farbe(farben);
        else
            farbe_rwert(farben);
        printf("Nochmal (1='Ja' 2='Nein')");
    } while (eingabe(1,2) == 1);
    return 0;
}

int eingabe(int min, int max) {
    int zahl;

    while(1) {
        scanf("%d", &zahl);
        if (zahl >= min && zahl <= max)
            return zahl;
        printf("\a\n");
    }
}

void farbe_rwert(int ringzahl) {
    int i, code[4] = {0,0,0,0}, rwert;
    for (i=0; i<10; i++)
        printf("%d)\t%s\n", i, farbtext[i]);
    printf("Geben Sie VON RECHTS HER die %d Farben ein:", ringzahl);
    for (i=0; i<ringzahl; i++)
        code[i] = eingabe(0,9);
    rwert=(100*code[3]+10*code[2]+code[1])*(int)pow(10,code[0]);
    printf("R-Wert: %d\n", rwert);
}

void rwert_farbe(int ringzahl) {
    int rwert, lang, i;
    printf("Geben Sie den Widerstandswert ein:");
    rwert = eingabe(1,9000000);
    lang = log10(rwert) + 1 - (ringzahl -1); // Exponenten-Ring
    rwert = rwert / (int) pow(10, lang);     // Mantisse
    for (i=ringzahl - 2; i >=0; i--)
        printf("%s  ", farbtext[rwert / (int)pow(10,i) % 10]);
    printf("%s\n", farbtext[lang]);
}
