/**********************************************************
Scanner 1 fr Aloisius-Automat
Ausgabealphabet:
Ende    : 0
"ha"    : 1
"l"     : 2
"le"    : 3
"lu"    : 4
"u"     : 5
"ja"    : 6
Fehler  : 7
**********************************************************/
#include <stdio.h>

int aloisius_scanner(char *in, int reset) {
    static char *p;
    static int delta[4][8]={/*   E h a l e u j F  */
                          /*0*/ { 4, 1,11, 2,11, 9, 3,11},
                          /*1*/ {11,11, 5,11,11,11,11,11},
                          /*2*/ { 6, 6, 6, 6, 7, 8, 6, 6},
                          /*3*/ {11,11,10,11,11,11,11,11}};
    int chartyp[256] = {
0,7,7,7,7,7,7,7,7,7,0,7,7,0,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,2,7,7,7,4,7,7,1,7,6,7,3,7,7,2,7,7,7,7,7,5,7,7,7,7,7,7,7,7,7,7,
7,2,7,7,7,4,7,7,1,7,6,7,3,7,7,2,7,7,7,7,7,5,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7};
    int zustand = 0;
    if (reset) {
        p = in;
        return 0;
    }
    while (zustand < 4) {
        zustand = delta[zustand][chartyp[*p++]];
    }
    if (zustand == 6)
        p--; // Lookahead rckgngig machen
    return zustand - 4;
}

int main() {
    char t[255];
    int token;

    while (printf("In:"),fgets(t, 255, stdin) != NULL) {
        aloisius_scanner(t, 1);
        while ((token = aloisius_scanner(t, 0)) != 0)
            printf("%3d", token);
        printf("\n");
    }
    return 0;
}