/**********************************************************
Testprogramm fr LEX-Scanner
**********************************************************/
#include <stdio.h>
enum {END, ZAHL, PLUS, MINUS, MAL, DIV, KLA_AUF, KLA_ZU, ERROR};
double yylval;
#include "lex.yy.c"

int main() {
    int token;

    printf("Geben Sie eine Rechnung ein:");
    while ((token = yylex()) != END) {
        switch (token) {
        case ZAHL:      printf("Zahl %lf\n", yylval); break;
        case PLUS:      printf("+\n"); break;
        case MINUS:     printf("-\n"); break;
        case MAL:       printf("*\n"); break;
        case DIV:       printf("/\n"); break;
        case KLA_AUF:   printf("(\n"); break;
        case KLA_ZU:    printf(")\n"); break;
        case ERROR:     printf("Eingabefehler\n"); break;
        default:        printf("Internes Problem!"); break;
        }
    }
}