/**********************************************************
Automat sucht in einem Text den regulren Ausdruck
"lol""l"*("o"|"a")
Bsp. lola, lollla, lollo
**********************************************************/
#include <stdio.h>
int lola_parser(char * in) {
    int ctyp[256] = {
0,4,4,4,4,4,4,4,4,4,0,4,4,0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,3,4,4,4,4,4,4,4,4,4,4,1,4,4,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,3,4,4,4,4,4,4,4,4,4,4,1,4,4,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4};
/*  ctyp['\0']=ctyp['\n']=ctyp['\r']=0
    ctyp['L']=ctyp['l']=1
    ctyp['O']=ctyp['o']=2
    ctyp['A']=ctyp['a']=3
    alle anderen Indizes x: ctyp[x] = 4 */
    int delta[4][5] = {/*  E  l  o  a  R */
                    /*0*/ {4, 1, 0, 0, 0},
                    /*1*/ {4, 1, 2, 0, 0},
                    /*2*/ {4, 3, 0, 0, 0},
                    /*3*/ {4, 3, 0, 0, 0}};
    int lambda[4][5] = {/* E  l  o  a  R */
                    /*0*/ {0, 0, 0, 0, 0},
                    /*1*/ {0, 0, 0, 0, 0},
                    /*2*/ {0, 0, 0, 0, 0},
                    /*3*/ {0, 0, 1, 1, 0}};
    int zustand = 0, pos = -1, token;
    while (zustand != 4) {
        token = ctyp[*(in + ++pos)];
//        printf("Zustand %d, Token %d ", zustand, token);
        if (lambda[zustand][token])
            printf("Treffer, Ende an Stelle %d\n", pos);
        zustand = delta[zustand][token];
//        printf("--> wechsle in Zustand %d\n", zustand);
    }
}

int main() {
    char text[256] =
"als Lola die Laolawelle sah sang sie olala, Lllollorossosalat";

/*    printf("Geben Sie einen Text ein:\n");
    fgets(text, 255, stdin); */
    printf("Durchsuche\n\"%s\"\n", text);
    printf("nach \"lol\"\"l\"*(\"a\"|\"o\"):\n\n");
    lola_parser(text);
    return 1;
}
