/*****************************************************************************
Rechner fr mathematische Grundrechenarten ohne Punkt-vor-Strich
Winfried Bantel / BA Stuttgart
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "mathe_scanner.c"

int main() {
	char input[255];
	int token, zustand,operator,vorzeichen;
	double wert,zahl;
	int parsetable[3][7]={	{4,2,2,4,4,1,4},
							{3,0,0,0,0,4,4},
							{4,4,4,4,4,1,4}};
	while (1) {
		printf("Brauche Input: ");
		fgets(input,255,stdin);
		input[strlen(input)-1] = 0;
		if (!*input)
			break;
		zustand = 0;
		wert=0;
		vorzeichen = PLUS;
		operator=PLUS;
		do {
			token = lex_mathe(input, &zahl);
//			printf("Zustand %d Token %d gehe zu %d\n",zustand,token,parsetable[zustand][token]);
			zustand = parsetable[zustand][token];
			switch (zustand) { // Jetzt Programmcode der ausprogrammiert werden muss
			case 0: // Operator merken
				operator = token;
				break;
			case 1: // Rechnen
//				printf("Rechne, VZ=%d OP=%d\n",vorzeichen,operator);
				zahl = (vorzeichen == PLUS) ? zahl : -zahl;
				switch (operator) {
					case PLUS:	wert += zahl;
								break;
					case MINUS: wert -= zahl;
								break;
					case MAL:	wert *= zahl;
								break;
					case DIV:	wert /= zahl;
								break;
					default:	printf("Fehler im Operator!\n");
				}
//				printf("Wert jetzt %lf\n",wert);
				vorzeichen=PLUS; // Default-Vorzeichen fr nchste Zahl
				break;
			case 2: // Vorzeichen merken
				vorzeichen = token;
//				printf("Neues Vorzeichen: %d\n",vorzeichen);
				break;
			default:
			}
		} while (zustand < 3);
		if (zustand == 3)
			printf("Eingabe OK, Ergebnis: %lf\n",wert);
		else
			printf("Eingabe war nicht OK!\n");
	}
	printf("\n");
}
