/**********************************************************
Klasse c_vektor
Header-Datei
**********************************************************/
#ifndef _C_VEKTOR_H
#define _C_VEKTOR_H 1
#include <iostream.h>
#include <ctype.h>

class c_vektor {
public:
// Konstruktoren und Destruktoren
	c_vektor();
	c_vektor(double, double);

// Methoden
	void set(double, double);
	double betrag(void);
	double get_x(void);
	void set_x(double);
	double get_y(void);
	void set_y(double);
	void drehe(double);
	
// Operatoren
	c_vektor operator + (c_vektor); // Vektoraddition
	c_vektor operator - (c_vektor); // Binres Minus (Subtraktion)
	c_vektor operator - ();         // Unres Minus (Negation)
	double operator * (c_vektor);   // Skalarprodukt
	c_vektor operator * (double);   // Skalarprodukt
	double operator [] (char);      // Index

// Friend-Funktionen
    friend ostream& operator << (ostream&, const c_vektor&);
    friend istream& operator >> (istream&, c_vektor&);
    friend c_vektor vektor_add(c_vektor, c_vektor);
private:
    double x, y;
};

#include "cpp_c_vektor.cpp"

#endif