class vector {
private:
    double x, y;

public:
    void set(double, double);
    double getx(void);          // Rckgabe X-Komponente
    double gety(void);          // Rckgabe Y-Komponente
    double betrag(void);        // Rckgabe Betrag des Vektors
    double winkel(void);        // Rckgabe Winkel des Vektors
    void drehe(double alpha);   // Drehe Vektor, alpha im Bogenma
    void drehe(int alpha);      // Drehe Vektor, alpha im Gradma
};

void vector::set(double x_, double y_) {
    x = x_;
    y = y_;
}

double getx(void){
    return x;
}

double gety(void){
    return y;
}

double betrag(void){
    return sqrt(x * x + y * y);
}

double winkel(void) {
    if (x)
        return (int) (atan(y / x) / M_PI * 180);
    else
        return (y>=0) ? 90 : 270;
}

void drehe(double alpha) {
    double x2 = x, s = sin(alpha), c = cos(alpha);
    x = c * x2 - s * y;
    y = s * x2 + s * y;
}

void drehe(int alpha) {
    drehe((int) (alpha / 180.0 * M_PI)); // Keine Rekusrion!
}