/**********************************************************
Sieb des Eratosthenes
Dateiverarbeitung
**********************************************************/
#include <stdio.h>

int main() {
	char c;
	unsigned int z, i, max;
	FILE *f;
	char filename[]="/tmp/eratosthenes.txt"; // Abndern!!!
	
	f = fopen(filename,"w+"); // Neu anlegen, R/W
	if (f == NULL) {
	    fprintf(stderr, "Error '%s'\n", filename);
	    return 1;
	}
	
	printf("Bis zu welcher Zahl:");
	scanf("%d", &max);
	printf("Initialisiere Datei...\n", max);
	for (i=3; i < max; i += 2) {
	    fseek(f, i/2-1, SEEK_SET);
	    fwrite("1", sizeof(char), 1, f);
    }
	
	printf("Berechnung der Primzahlen von 3 bis %d\n", max);
	for (z=3; z < max; z+=2) {
	    fseek(f, z/2-1, SEEK_SET);
	    fread(&c, sizeof(char), 1, f);
		if (c == '1') {
			printf("%8d\n",z);
			for (i=3*z; i < max; i +=  2*z) {
        	    fseek(f, i/2-1, SEEK_SET);
        	    fwrite("0", sizeof(char), 1, f);
		    }
		}
    }
    fclose(f);
	return 0;
}