/**********************************************************
Kopiert Textdatei mit Int-Zahlen in Binrdatei, sortiert
diese und gibt die Zahlen sortiert in Standardausgabe aus
**********************************************************/

#include <stdio.h>

int main(int argc, char *argv[]) {
    int zahl, z[2], anz=0, i, j;
    FILE *in, *out;

    if (argc != 3) {
        fprintf(stderr,"Aufruf mit zwei Dateinamen!\n");
        return 1;
    }
    in = fopen(argv[1], "r");
    if (in == NULL) {
        fprintf(stderr, "Kann Eingabedatei nicht ffnen!\n");
        return 1;
    }
    out = fopen(argv[2], "w+");
    if (out == NULL) {
        fprintf(stderr, "Kann Ausgabedatei nicht ffnen!\n");
        return 1;
    }

// Schritt 1: Eingabedatei (Textformat)
// in Ausgabedatei (Binrformat) kopieren
    while (fscanf(in, "%d", &zahl) != EOF) {
        fwrite(&zahl, sizeof(int), 1, out);
        anz++;
    }
    printf("%d Zahlen gelesen, sortiere...\n", anz);
    fclose(in);
// Schritt 2: Bubble-Sort
    for (i = 0; i < anz; i++)
        for (j = 0; j < anz-1; j++) {
            fseek(out, j * sizeof(int), SEEK_SET);
            fread(z, sizeof(int), 2, out);
            if (z[0] > z[1]) {
                fseek(out, j * sizeof(int), SEEK_SET);
                fwrite(z+1, sizeof(int), 1, out);
                fwrite(z, sizeof(int), 1, out);
            }
        }
// Scritt 3: Ausgabedatei einlesen und in stdout ausgeben
    fseek(out, 0, SEEK_SET);
    for (j = 0; j < anz; j++) {
        fread(&zahl, sizeof(int), 1, out);
        printf("Zahl %d: %d\n", j, zahl);
    }
    fclose(out);
}