#include <stdio.h>

int main(int argzahl, char *argumente[]) {
    int wortzahl = 0;
    FILE *in;
    char dummy[2000];

    if (argzahl == 1) {
        in = stdin;
        fprintf(stderr, "Lese aus Standard-Eingabe\n");
    }
    else {
        in = fopen(argumente[1], "r");
        if (in == NULL) {
            fprintf(stderr, "Dateifehler '%s'!\n", argumente[1]);
            return 1;
        }
        fprintf(stderr, "Lese aus Datei '%s'\n", argumente[1]);
    }
    while (fscanf(in, "%s", dummy) != EOF)
        wortzahl++;
    printf("%d Wort%s\n", wortzahl, (wortzahl==1) ? "" : "e");
    return 0;
}