/**********************************************************
Demonstriert nichtinitialisierte und unterinitialisierte
mehrdimensionale Felder.
Die Felder a und b haben jeweils drei Zeilen und
vier Spalten.
**********************************************************/
#include <stdio.h>

int main() {
    int a[3][4] = { {1,2,3,4}, // Mehrdimensional initialisiert
                    {2,3,4,5},
                    {6,5,4,3}};
    int b[3][4] = {0};         // Unterinitialisiert - 0-Feld
    int c[3][4];               // Nicht initialisiert
    int z, s;

    printf("     a     |      b\n------------------------\n");
    for (z = 0; z < 3; z++)
        for (s = 0; s < 4; s++) {
            printf("a[%d][%d]=%d\t", z, s, a[z][s]);
            printf("b[%d][%d]=%d\t", z, s, b[z][s]);
            printf("c[%d][%d]=%d\n", z, s, c[z][s]);
        }
    return 0;
}

