/**********************************************************
Berechnet den nchsten Nachbarn eines Punktes
**********************************************************/
#include <stdio.h>
#include <math.h>

typedef struct {
    double x, y;
} punkt;

double abstand(punkt, punkt);

int main() {
    const int n = 3;
    punkt m[] = {{3,4},{1,2},{-1,-1}};
    int nn, i;
    punkt p;

    printf("Punktmenge:\n");
    for (i = 0; i < n; i++)
        printf("(%lf/%lf)\n", m[i].x, m[i].y);

    printf("Geben Sie die Koordinaten von p ein: ");
    scanf("%lf%lf", &p.x, &p.y);
    nn = 0;
    for (i = 1; i < n; i++)
        if (abstand(p, m[i]) < abstand(p, m[nn]))
            nn = i;
    printf("Naechster Nachbar: (%lf/%lf)\n", m[nn].x, m[nn].y);
    return 0;
}

double abstand(punkt p1, punkt p2) {
    return sqrt(pow(p1.x - p2.x, 2) + pow(p1.y - p2.y, 2));
}

