/**********************************************************
Eingabe, Sortierung und Ausgabe von zwei Studenten
**********************************************************/
#include <stdio.h>

struct student {
    char nachname[30], vorname[30];
    int matrikelnr, erstsemester;
};

void student_sort(struct student *, struct student *);
struct student student_eingabe();
void student_ausgabe(struct student);

int main() {
    struct student s1, s2;

    s1 = student_eingabe();
    s2 = student_eingabe();
    student_sort(&s1, &s2);
    student_ausgabe(s1);
    student_ausgabe(s2);
    return 0;
}

void student_sort(struct student *a, struct student *b) {
    struct student dummy;
    if (strcmp(a->nachname, b->nachname)>1) {
        dummy = *a;
        *a = *b;
        *b = dummy;
    }
}

struct student student_eingabe() {
    struct student s;
    printf("Studenten-Eingabe:\n");
    printf("Nachname:     ");
    scanf("%s", s.nachname);
    printf("Vorname:      ");
    scanf("%s", s.vorname);
    printf("Matrikelnr    ");
    scanf("%d", &s.matrikelnr);
    printf("Erstsemester: ");
    scanf("%d", &s.erstsemester);
    return s;
}

void student_ausgabe(struct student s){
    printf("%30s %30s", s.nachname, s.vorname);
    printf("%8d%6d\n", s.matrikelnr, s.erstsemester);
}
