#include <stdio.h>
#include <math.h>

void ausgabe(double *, int);
double determinante(double *, int);
int main() {
/*    double a[5][6]={    { 6,-3, 2, 1,-1, 5},
                        { 3, 7, 0,-4, 2,11},
                        { 4,-3, 6,-1, 2,22},
                        { 2, 4, 5,-7,-3,-18},
                        {-1, 5,-4, 0, 8,37}};*/
    double a[3][3]={{0,2,3},{0,5,6},{0,8,9}};

    printf("det = %f\n", determinante(&(a[0][0]), 3));
    return 0;
}

double determinante(double *a, int n) {
/*  Berechnet Determinante der Matrix *a. Gre wird in n bergeben
    Zeiger-Arithmetik wird durch Prprozessor-Define A erledigt!!!
*/
    int s, z, i, dummy;
    int mult = 1;
    double m; // Hilfsvariable
#define A(zeile,spalte) *(a + zeile * n + spalte)
    ausgabe(a, n);
    for (s = 0; s < n-1; s++) {
        m = 0;  // Betragsmg grsstes Element
        i = 0;  // Zeile mit grsstem Element
        for (z = s; z < n; z++) // Max. Element suchen
            if (fabs(A(z,s)) > fabs(m)) {
                m = A(z,s);
                i = z;
            }
        if (i != s) {// Tauschen Zeile i mit Zeile s
            for (dummy = 0; dummy < n; dummy++) {
                m = A(s, dummy);
                A(s, dummy) = A(i, dummy);
                A(i, dummy) = m;
            }
            mult = -mult; // Zeilentausch kehrt Det-Vorzeichen um
        }
        for (z = s+1; z<n; z++)
            if (A(z,s) != 0 && A(s,s) != 0){
                m = A(s, s) / A(z, s);
                for (dummy = 0; dummy < n+1; dummy++)
                    A(z, dummy) -= (A(s, dummy) / m);
        }
        ausgabe(a, n);
    }
    m = (double) mult;
    for (dummy=0; dummy<n; dummy++)
        m *= A(dummy, dummy);
    return m;
#undef A
}

void ausgabe(double *a, int n) {
    int i, j;
    printf("\n");
    for (i=0; i<n; i++) {
        for (j=0; j<n; j++)
            printf("%13f", *(a + n * i + j));
        printf("\n");
    }
    printf("\n");
}