/**********************************************************
Rekursive Berechnung der Determinante einer Matrix
Gelst mit Zeiger-Arithmetik
Ausfhrung von malloc() wird NICHT berprft!!!!!
**********************************************************/
#include <stdio.h>
#include <malloc.h>

double det(double *, int);
void ausgabe(double *, int);

int main() {
    double a[3][3]={{1,2,3},
                    {4,5,6},
                    {7,8,9}};
    printf("d = %lf\n", det(&(a[0][0]),3));
    return 0;
}

double det(double *m, int dim) {
    int i, j, k, dim2 = dim-1;
    double * sub;
    double d = 0;
    // ausgabe(m, dim);

    if (dim == 1) // Rekursionsabbruch
        d = *m;
    else { // Rekursiver Teil
        sub = (double *) malloc((dim2) * (dim2) * sizeof(double));
        for (i=0; i<dim; i++)
            if (*(m + i) != 0) {
                for (j=0; j < dim2; j++)        // Untermatrix
                    for (k=0; k < dim2; k++)    // erzeugen
                        *(sub + dim2 * j + k) =
                            *(m + dim * (j+1) + ((k < i) ? k : k+1));
                if (i % 2 == 0)
                    d += (*(m + i) * det(sub, dim2)) ;
                else
                    d -= (*(m + i) * det(sub, dim2)) ;
        }
        free(sub);
    } // Rekursiver Teil
    return d;
}

void ausgabe(double *m, int dim) {
    int i, j;
    for (i=0; i<dim; i++) {
        for (j=0; j<dim; j++)
            printf("\t%lf", *(m + dim * i + j));
        printf("\n");
    }
    printf("\n");
}
