#include <stdio.h>
#include "numerik_dateneinlesen.h"

double differenziere(int i, int anzahl) {
    double ergebnis;
    if (i == 0) // Erste Sttzstelle
        ergebnis =
        (daten[1].y-daten[0].y) / (daten[1].x-daten[0].x);
	else if (i == anzahl -1) // Letzte Sttzstelle
        ergebnis =
        (daten[i].y-daten[i-1].y) / (daten[i].x-daten[i-1].x);
	else // Sttzstelle nicht am Rand
        ergebnis =
        ((daten[i+1].y-daten[i].y) / (daten[i+1].x-daten[i].x) +
        (daten[i].y-daten[i-1].y) / (daten[i].x-daten[i-1].x)) / 2;
    return ergebnis;
}

int main() {
    int i, anzahl;

	if ((anzahl = einlesen()) == 0)
	    return 1; // Fehler
	printf("%10s\t%10s\t%10s\n", "x", "y", "y'");
	printf("--------------------------------------------------\n");
	for (i=0; i<anzahl; i++) {
	    printf("%10.3lf\t%10.3lf\t", daten[i].x, daten[i].y);
	    printf("%10.3lf\n", differenziere(i,anzahl));
	}
	return 0;
}