#include <stdio.h>
#include <limits.h>

unsigned long int perm_r(unsigned long int, unsigned long int);
unsigned long int perm_i(unsigned long int, unsigned long int);

int main() {
    unsigned long int z1, z2;

    printf("Geben Sie zwei Zahlen ein: ");
    scanf("%ld%ld", &z1, &z2);

    printf("iter: %ld\n", perm_i(z1, z2));
    printf("rek : %ld\n", perm_r(z1, z2));
}

unsigned long int perm_r(unsigned long int n, unsigned long int k) {
    if (k == n || k == 0)
        return 1;
    else
        return perm_r(n-1,k-1) * n / k;
}

unsigned long int perm_i(unsigned long int n, unsigned long int k) {
    unsigned long int i, erg = 1;
    for (i=n-k+1; i<=n; i++) {
        if (erg > UINT_MAX / i)
            return -1;
        erg *= i;
    }
    for (i=1; i<=k; i++)
        erg /= i;
    return erg;
}