/**********************************************************
Sieb des Eratosthenes
Winfried Bantel
**********************************************************/

#include <stdio.h>
#include <math.h>
#include <limits.h>

#define MAX 1000000
int main() {
	unsigned int zahl, grenze, k, prim;
	unsigned int primzahlen[MAX], primzahlnr=0;
	
	printf("Berechnung der ersten %d Primzahlen\n%10d", MAX, 2);
	
	zahl = 3;
	do {
		k=0;
		prim=1;
		grenze = (int) sqrt(zahl);
		while (k<primzahlnr && prim && primzahlen[k] <= grenze) {
			prim = (zahl % primzahlen[k] != 0);
			k++;
		}
		if (prim) {
			primzahlen[primzahlnr++]=zahl;
			printf("%10d", zahl);
		}
		zahl += 2;
	} while (primzahlnr < MAX && zahl <= UINT_MAX);
	printf("\n");
	return 0;
}