/********************************************************
Fakultt - rekursive und iterative Implementierung
********************************************************/
#include <stdio.h>

unsigned long int fakultaet_iterativ(unsigned long int n)
{
   unsigned long int i, f = 1;

   for (i=1; i <= n; i++)
      f *= i;
   return f;
}

unsigned long int fakultaet_rekursiv(unsigned long int n)
{
   return (n == 0) ? 1 : (n * fakultaet_rekursiv(n-1));
}

int main(){
    int zahl;

    printf("Geben Sie eine Zahl ein: ");
    while (scanf("%d",&zahl) != EOF) {;
        printf("Iterativ:\t%ld\n",fakultaet_iterativ(zahl));
        printf("Rekursiv:\t%ld\n",fakultaet_rekursiv(zahl));
        printf("Geben Sie eine Zahl ein: ");
     }
     printf("\n");
     return 0;
}