/**********************************************************
Merge-Sort rekursiv durch teilen des Datenfeldes in zwei
Teile, rekurisve Sortierung der Teile, dann zusammenmischen
**********************************************************/
#include <stdio.h>

int data[8] = {8,7,6,5,4,3,2,1};

void ausgabe(int, int);
void mergesort(int, int);

int main() {
    ausgabe(0,7);
    mergesort(0,7);
    ausgabe(0,7);
    return 0;
}

void mergesort(int l, int r){
    int m = (l+r) / 2,  i, a = l, b = m+1;
    int *p = (int *) malloc((r - l + 1) * sizeof(int));

    if (l == r) // Rekursions-Abbruch
        return;
    mergesort(l, m);
    mergesort(m+1, r);
    for (i=0; i< = r-l; i++) // Mischen
        *(p+i) = (b>r || a<=m && data[a] < data[b]) ?
            data[a++] : data[b++];
    for (i=0; i <= r-l; i++) // zurckkopieren
        data[l+i]=*(p+i);
    free(p); // Speicher freigeben!
}

void ausgabe(int li, int re) {
    int i;
    printf("li=%d re=%d", li, re);
    for (i=li; i<=re; i++)
        printf("\t%d", data[i]);
    printf("\n");
}