/*********************************************************
Gibt alle Permutationen eines Feldes aus
**********************************************************/
#include <stdio.h>
void ausgabe();
void permutiere(int);

const int anz = 3; // Gre des zu permutierenden Feldes
int x[] = {1,2,3}; // Zu permutierendes Feld

void permutiere(int n) { // Permutiere anz Elemente ab x
    int i, merk;
    if (n == anz -1) // Rekursionsabbruch
        ausgabe();
    else
        for (i=n; i<anz; i++) {
            merk = x[n];
            x[n] = x[i];
            x[i] = merk;
            permutiere(n + 1);   // Rekursion
            x[i] = x[n];
            x[n] = merk;
        }
}

void ausgabe() {
    static int i, nr;
    printf("%3d)", ++nr);
    for (i=0; i < anz; i++)
        printf("%4d", x[i]);
    printf("\n");
}

int main () {
    permutiere(0);
}
