/************************************************************
Blocksatz-Programm
Liest Input aus der Standart-Eingabe und formatiert ihn im
Blocksatz mit Zeilenbreite, die als Parameter bergeben
werden muss.
************************************************************/
#include <stdio.h>

void format(char *zeile, int breite) {
// Formatiert *zeile im Blocksatz mit breite als Zeilenbreite
// *zeile muss als worttrenner exakt ein Leerzeichen haben
    char *p = zeile, hilf[255], *lauf=hilf;
    int i, j, luecken = 0, diff, wortnr=0;
    int anz, leer, lang = 0, anzahl;

    for (i=0; i<strlen(zeile); i++) // Lcken und Buchstaben zhlen
        if (zeile[i] == ' ')
            luecken++;
        else
            lang++;
    if (!luecken) // Nur ein Wort -> kein Blocksatz!
        return;
    diff = breite - lang;        // Soviel Leerzeichen ntig
    leer = diff / luecken;       // Breite der Lcke (schmal)
    anz = diff - luecken * leer; // anz Lcken mssen 1 breiter sein

    for (i=0; i<=strlen(zeile); i++) {
        if (zeile[i] != ' ')
            *(lauf++) = zeile[i];
        else {
            anzahl = (wortnr++ < anz) ? leer+1 : leer;
            for (j=0; j<anzahl; j++)
                *(lauf++) = ' ';
        }
    }
    strcpy(zeile,hilf);
}

int main(int argc, char *arg[]) {
    char zeile[255] = "", wort[255];
    int breite, i;

    breite = (argc == 2) ? atoi(arg[1]) : 72;
    while (scanf("%s", wort) != EOF) {
        if (strlen(zeile) + 1 + strlen(wort) > breite) {//Zu breit
            format(zeile, breite);
            printf("%s\n", zeile);
            strcpy(zeile, wort);
        }
        else {
            if (*zeile)
                strcat(zeile, " ");
            strcat(zeile, wort);
        }
    }
    if (*zeile)
        printf("%s\n", zeile); // Letzte Zeile ohne Blocksatz!
    return 0;
}