/**********************************************************
Verifikation der Goldbachschen Vermutung
**********************************************************/
#include <stdio.h>
#include <math.h>

int prim(int z) {
    int i, grenze = (int) sqrt(z);
    for (i=3; i<=grenze; i++)
        if (z % i == 0)
            return 0;
    return 1;
}

int main() {
    int i, j, ok;

    for (i=10; i<300000; i += 2) {
        printf("%d", i);

        ok = 0;
        for (j=3; j < i - 2; j += 2)
            if (prim(j) && prim(i-j)) {
                printf("%10d%10d", j, i-j);
                ok = 1;
                break;
            }

        printf(ok ? " OK!\n" : " NICHT OK!!!!!\n");
        if (!ok)
            break;
    }
}
