/********************************************************
Roulette-Simulation
********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <limits.h>

int main() {
    unsigned int spiel = 1, limit = 0, spielzahl = 10000;
    unsigned int einsatz_1=10, einsatz_2=10, schwarz = 0, rot = 0;
    int cash_1 = 0, cash_2 = 0;

    srand(time(NULL));

    do {
        printf("Spiel %d: ", spiel);
        cash_1 -= einsatz_1;
        cash_2 -= einsatz_2;
        if ((double) rand() / RAND_MAX <= 18.0 / 37) { // Gewonnen
            printf("Gewonnen");
            rot++;
            cash_1 += (2*einsatz_1);
            cash_2 += (2*einsatz_2);
            einsatz_2 = 10;
        }
        else { // Verloren
            printf("Verloren");
            einsatz_2 *= 2;
            if (limit && einsatz_2 > limit)
                einsatz_2 = 10;
        }
        printf("\n");
    } while (spiel++ < spielzahl || einsatz_2 > 10);
    printf("Anzahl Rot: %d (%.2lf%%)\n", rot, 100.0 *rot / spiel);
    printf("Spieler 1: %d Euro\n",cash_1);
    printf("Spieler 2: %d Euro\n",cash_2);
}