/************************************************************
Sortiern durch direktes Tauschen
Rekursiv implementiert
************************************************************/
#include <stdio.h>
void ausgabe(int[], int);
void tausch_sort(int [], int);

int main() {
    int feld[]={5,7,8,2,4,3,6,1}; // Zu sortierendes Feld
    tausch_sort(feld, 8);
    ausgabe(feld, 8);
    return 0;
}

void tausch_sort(int feld[], int n) {
	int i, dummy, pos = 0;
	ausgabe(feld, n);
	for (i = 1; i < n; i++)
		if (feld[i] < feld[pos])
		    pos = i;
	if (pos != 0) { // Dreieckstausch
        dummy=feld[0];
		feld[0]=feld[pos];
        feld[pos]=dummy;
	}
    ausgabe(feld, n);
    if (n > 2) // Rekursion bzw. Rekursionsabbruch
        tausch_sort(feld+1, n-1);
}

void ausgabe(int feld[], int n) {
    int j;
	for (j = 0; j < n; j++)
		printf("%3d", feld[j]);
    printf("\n");
}
