#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

int zufallszahl(int min, int max) {
    static int firsttime = 1;
    double z;
    if (firsttime) { // Nur bein ersten mal
        firsttime = 0;
        srand(time(NULL));
    }
    z = (double) rand() / ((double)RAND_MAX + 1.0);
    // z jetzt im Bereich [0,1[ (0 incl., 1 excl.
    z *= (max - min + 1);
    // z jetzt im Bereich [0,max-min+1[ (0 incl., max-min+1 excl.
    z += min;
    // z jetzt im Bereich [min,max+1[ (0 incl., max-min+1 excl.
    return (int) floor(z);
}

int main() {
    int i;

    for (i=0; i<100; i++)
        printf("%4d",zufallszahl(2,8));
    printf("\n");
}